#include "FastLED.h"
#define NUM_LEDS 100  // # of LEDS in the strip
#define DATA_PIN 2 // Output Pin to Data Line on Strip

CRGB leds[NUM_LEDS];

void setup() {
    FastLED.addLeds<WS2812B, DATA_PIN, GRB>(leds, NUM_LEDS).setCorrection( TypicalLEDStrip ); 
}

void loop() {
    int hue = get_hue();
    int new_brightness = get_brightness();
    if (new_brightness < 50) {
        new_brightness = 50;
    }
    for(int i = 0; i < NUM_LEDS; i++ )
    { 
       leds[i] = CHSV(hue,255,new_brightness);
    }
    FastLED.show();
    FastLED.delay(100);
}

uint16_t gHue = 0;
uint8_t  gHueDelta = 1;
int get_hue() {
    gHue += gHueDelta;
    gHue = gHue % 255;
    return gHue;
}

int brightness = 0;
int fadeAmount = 1;  // 5, 10, 15, 20, 25, ..., 255.
int get_brightness() {
  brightness = brightness + fadeAmount;
  if(brightness == 0 || brightness == 255)
  {
    fadeAmount = -fadeAmount;
  }
  return brightness;
}
